
// constants
var VERSION = 1,
		EMAIL_OR_ID = "email_or_id",
    REFRESH_INTERVAL = "refresh_interval",
    HM_ROOT = "http://headmagnet.com",
    HM_STATS_URL = HM_ROOT + "/stats",
    HM_PROFILE_URL = HM_ROOT + "/profiles",
    LAST_DATA = "last_data",
    HM_LEARN_URL = HM_ROOT + "/lessons/learn",
    HM_REVIEW_URL = HM_ROOT + "/lessons/review",
    VIEW_MODE = 'view_mode',
    VIEW_MODE_BAR = "view1",
    VIEW_MODE_STATS = "view2",
		HM_VERSION_CHECK_URL = HM_ROOT + "/widget_version.json";
    
// variables
var emailOrId = null,
    refreshInterval = null,
    refreshTimer = null,
    lastData = null,
    viewMode = VIEW_MODE_BAR,
		refreshInProgress = true,
		newVersionLink = null,
		lastRefesh = null,
		newVersionTimer = null;

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();

}
function setPref(pref, value)
{
	return result = widget.setPreferenceForKey(value, widget.identifier + "-" + pref);
}
function clearPref(pref)
{
	return setPref(pref, value);
}
function timestamp()
{
	return((new Date()).getTime());
}
function getPref(pref, defaultValue)
{
    var value = widget.preferenceForKey(widget.identifier + "-" + pref);
    value = ((value==null) ? defaultValue : value);
    return value;
}

function nextStackView()
{
    var stackLayout = document.getElementById('stackLayout').object,
        currentView = stackLayout.getCurrentView().id,
        nextView = (currentView == VIEW_MODE_STATS) ? VIEW_MODE_BAR : VIEW_MODE_STATS;
    viewMode = nextView;
		setPref(VIEW_MODE, viewMode);
    updateStackView();
}

function updateStackView()
{
    viewMode = (viewMode == VIEW_MODE_STATS) ? VIEW_MODE_STATS : VIEW_MODE_BAR;
    document.getElementById('stackLayout').object.setCurrentView(viewMode);
}
//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
		clearPref(EMAIL_OR_ID);
		clearPref(REFRESH_INTERVAL);
		clearPref(VIEW_MODE);

    clearRefreshTimer();
}

function clearRefreshTimer()
{
   clearTimeout(refreshTimer);
   refreshTimer = null;
}

function refreshCallback(data,textStatus, xhr)
{
    if (!data || !data.user)
    {
        data = 
        {
            user:
            {
                name:(xhr && xhr.status != 200) ? "Could not connect to server." : "Please enter a valid user id or email",
                pic:"Images/default_pic_medium.png",
                url:HM_ROOT,
                study_time:"",
                id:null
            },
            profile:
            {
                current_strength:0,
                week1_strength:0,
                week2_strength:0,
                items:"",
                "new":"",
                old:"",
                strong:"",
                weak:""
            }
                
        }
    }

    $("#userName").text(data.user.name);

    if (data.user.pic == null || data.user.pic == '/images/default_pic_medium.png')
    {
        data.user.pic = 'Images/default_pic_medium.png';
    }
    $("#userPicture").attr("src", data.user.pic);
    
    $("#strengthCurrent .innerBar").css("width", percentage(data.profile.current_strength));
    $("#strength1Week .innerBar").css("width", percentage(data.profile.week1_strength));
    $("#strength2Weeks .innerBar").css("width", percentage(data.profile.week2_strength));

    $("#strengthCurrent .barLabel strong").text(percentage(data.profile.current_strength))
    $("#strength1Week .barLabel strong").text(percentage(data.profile.week1_strength))
    $("#strength2Weeks .barLabel strong").text(percentage(data.profile.week2_strength))

    $("#statCumulativeStudyTime").text(data.user.study_time);
    $("#statCurrentStrength").text(percentage(data.profile.current_strength));
    $("#stat1Week").text(percentage(data.profile.week1_strength));
    $("#stat2Weeks").text(percentage(data.profile.week2_strength));
    $("#statItemsTotal").text(data.profile.items);
    $("#statNewItems").text(data.profile["new"]);
    $("#statOldItems").text(data.profile.old);
    $("#statStrongItems").text(data.profile.strong);
    $("#statWeakItems").text(data.profile.weak);
    
    lastData = data;
		setPref(LAST_DATA, lastData);
    
    clearRefreshTimer();
    if (isNaN(refreshInterval) || refreshInterval == null || refreshInterval == 0)
    {
    }
    else
    {
        refreshTimer = setTimeout(refresh, 1000*refreshInterval);
    }
    setTimeout(stopRefreshInProgress, 0);

}
function percentage(val)
{
    if (val == null || val == "" || !val.toFixed)
    {
        return "0%";
    }
    return("" + val.toFixed(1) + "%");
}

function clearAll()
{
    var userName = "Loading...";
    if (emailOrId == null || emailOrId == "")
    {
        "No user selected."
    }

    $("userPicture").attr("src", "Images/default_pic_medium.png");

    $("#strengthCurrent .innerBar").css("width", "0%");
    $("#strength1Week .innerBar").css("width", "0%");
    $("#strength2Weeks .innerBar").css("width", "0%");

    $("#strengthCurrent .barLabel strong").text("")
    $("#strength1Week .barLabel strong").text("")
    $("#strength2Weeks .barLabel strong").text("")
}

function refresh()
{
		startRefreshInProgress();
		$("#userName").text("Loading...");
		clearRefreshTimer();
    if (emailOrId == null || emailOrId == "")
    {
			setTimeout(function(){refreshCallback(null);}, 0);
    }
    else
    {
        $.ajaxSetup({
            cache:false,
            timeout:30000
        });
				setTimeout(function(){$.getJSON(HM_STATS_URL, {email_or_id:emailOrId},  refreshCallback);}, 0);
    }
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
    clearRefreshTimer();
		clearTimeout(newVersionTimer);
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    emailOrId = getPref(EMAIL_OR_ID, null);
    refreshInterval = getPref(REFRESH_INTERVAL, 300);
    viewMode = getPref(VIEW_MODE, VIEW_MODE_BAR);
    updateStackView();
    // Restart any timers that were stopped on hide
		lastRefresh = null;
    refresh();
		newVersionTimer = setTimeout(checkNewVersion,5000);
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    // Values you provide
    emailOrId = $("#emailOrIdField").val();
    
    refreshInterval = parseInt($("#refreshIntervalDropdown").val());
    
    if (!refreshInterval || isNaN(refreshInterval))
    {
        refreshInterval = null;
    }
    
    // Preference code
		setPref(EMAIL_OR_ID, emailOrId);
		setPref(REFRESH_INTERVAL, refreshInterval);
    
		lastRefresh = null;
    refresh();
    
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function openHeadmagnet(event)
{
    widget.openURL(HM_ROOT);
}
function openHeadmagnetProfile(event)
{
    if (lastData && lastData.user && lastData.user.url && lastData.user.id)
    {
        url = lastData.user.url
        widget.openURL(url);
    }
    else
    {
        showBack(event);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function learnButtonClicked(event)
{
    widget.openURL(HM_LEARN_URL);
}


function reviewButtonClicked(event)
{
    widget.openURL(HM_REVIEW_URL);
}


function refreshClicked(event)
{
	if (!refreshInProgress)
	{
		lastRefresh = null;
		refresh();
	}
}

function startRefreshInProgress()
{
	refreshInProgress = true;
	$("#reloadButtonWrapper").hide();
}
function stopRefreshInProgress()
{
	$("#reloadButtonWrapper").fadeIn();
	refreshInProgress = false;
}

// if there is a new version, show the new version block
function versionCheckCallback(json)
{
	if (json != null && json["version"])
	{
		var newVersion = parseInt(json["version"]);
		if (!isNaN(newVersion) && newVersion > VERSION)
		{
			newVersionLink = json["location"];
			if (newVersionLink != null && newVersionLink != "")
			{
				$("#newVersionAvailable").fadeIn("slow");
			}
			else
			{
				hideUpgrader();
			}
		}
		else
		{
			hideUpgrader();
		}
	}
	else
	{
		hideUpgrader();
	}
}

function hideUpgrader()
{
	$("#newVersionAvailable").hide();
	newVersionLink = null;
}

function checkNewVersion()
{
	// run an ajax command to check to see if there is a new version
	setTimeout(function(){$.getJSON(HM_VERSION_CHECK_URL, versionCheckCallback);}, 0);
}

function openUpgradeWidgetLink(event)
{
	if (newVersionLink)
	{
		widget.openURL(newVersionLink);    
	}
}
